// 3、深拷贝
// 判断克隆对象克隆的函数
function getType( o ) {
    return Object.prototype.toString.call(o).slice(8, -1);
}
function deepClone(obj) {
    let result;
    // 首先判断克隆对象的类型
    if (getType(obj) === 'Array') {
        result = [];
    } else if (getType(obj) === 'Object'){
        result = {};
    } else {
        return obj;
    }

    // 根据类型进行递归深度克隆(此时必定为数组或者对象)
    for (const key in obj) {
        // 判断被拷贝对象中的每一项是否为对象，如果是，则递归( arguments.callee() )该对象
        if (getType(obj[key]) === 'Array' || getType(obj[key]) === 'Object') {
            result[key] = arguments.callee(obj[key]);
        } else {
        // 如果不是对象，则直接进行浅拷贝
            result[key] = obj[key];
        }
    }
    
    return result;
}
// 测试用例：
// let objTest = {
//     name: 'maojiuxu',
//     age: 18,
//     hobby:['basketall', 'game', 'read', 'shopping'],
//     sayHi: function () {
//         console.log('Hi!');
//     }
// }
// let newObj = deepClone(objTest);
// console.log(newObj);

// 暴露
exports.deepClone = deepClone;